var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
  else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { h } from '@stencil/core';
import { MapToComponentField, VegaSlimmer } from 'vega-slimmer/core';
export class VegaSelectionTileGroupRenderer extends VegaSlimmer {
  getGroupContainerRef() {
    return this.groupContainerRef;
  }
  render() {
    return (h("div", null,
      this.renderLabel(),
      this.renderContainer(),
      this.renderHint()));
  }
  renderLabel() {
    return (this.label && (h("div", { class: "vega-label" },
      h("label", { "aria-label": this.label },
        this.label,
        this.renderRequire()))));
  }
  renderRequire() {
    return this.required && h("span", { class: "vega-require" }, "*");
  }
  renderContainer() {
    return (h("div", { class: "container", ref: (e) => (this.groupContainerRef = e) },
      h("vega-flex", { direction: this.layout === 'horizontal' ? 'row' : 'col', gap: "size-12" },
        h("slot", { 
          /* eslint-disable-next-line react/jsx-no-bind */
          onSlotchange: 
          /**
           * The below method is e2e-test covered in
           * @see{module:vega-selection-tile-group-slot-change-e2e}
           */
          /* istanbul ignore next */
          () => this.itemsController.syncTileArrayAndValue() }))));
  }
  renderHint() {
    return (this.hint && (h("div", { class: "vega-hint" },
      h("label", null, this.hint))));
  }
}
__decorate([
  MapToComponentField()
], VegaSelectionTileGroupRenderer.prototype, "host", void 0);
__decorate([
  MapToComponentField()
], VegaSelectionTileGroupRenderer.prototype, "label", void 0);
__decorate([
  MapToComponentField()
], VegaSelectionTileGroupRenderer.prototype, "required", void 0);
__decorate([
  MapToComponentField()
], VegaSelectionTileGroupRenderer.prototype, "hint", void 0);
__decorate([
  MapToComponentField()
], VegaSelectionTileGroupRenderer.prototype, "layout", void 0);
__decorate([
  MapToComponentField()
], VegaSelectionTileGroupRenderer.prototype, "selectType", void 0);
__decorate([
  MapToComponentField()
], VegaSelectionTileGroupRenderer.prototype, "itemsController", void 0);
